# coding:utf-8
import Tkinter
import tkMessageBox


class CreateGUI(Tkinter.Frame):
    def __init__(self, r=10, width=150, height=150, master=None):
        print"class CreateGUI __init__()"
        Tkinter.Frame.__init__(self, master)

        self.param_data = ["string", "string", 0, 0, 0, 0, 0, 0, 0, 0, 0]

        # callback function
        self.on_write = None
        self.on_reset = None

        self.master.title(u"2DCDP Parameter setting")

        self.build_gui()

    def build_gui(self):
        print"class CreateGUI build_gui() start"

        self.topframe = Tkinter.Frame(self.master)
        self.topframe.pack()

        b_info = Tkinter.Button(
            self.topframe, bitmap="info",
            width=25, command=self.show_info)
        b_info.pack(side=Tkinter.RIGHT, padx=20, pady=10, anchor=Tkinter.N)

        self.create_editbox()
        self.create_radiobutton1()
        self.create_radiobutton2()
        self.create_radiobutton3()

        self.create_scaler1()
        self.create_scaler2()

        self.button1 = Tkinter.Button(
            self.topframe, text=u"PARAMETER SET & START",
            command=self.click_button1)
        self.button1.pack(expand=True, fill=Tkinter.BOTH)

        self.button2 = Tkinter.Button(
            self.topframe, text=u"DEFAULT PARAMETER SET & START ",
            command=self.click_button2)
        self.button2.pack(expand=True, fill=Tkinter.BOTH)

        self.button3 = Tkinter.Button(
            self.topframe, text=u"SYSTEM RESET",
            command=self.click_button3)
        self.button3.pack(expand=True, fill=Tkinter.BOTH)

        print"class CreateGUI build_gui() end"

    def create_editbox(self):
        self.frame = Tkinter.Frame(self.topframe)
        self.frame.pack(fill=Tkinter.BOTH, padx=10, pady=10)
        self.label = Tkinter.Label(
            self.frame, text=u"Specify the output file"
            u"\nidentification tag"
            u"\n(Up to 20 characters)")

        self.label.pack(side=Tkinter.LEFT)

        self.editbox_val = Tkinter.StringVar()
        self.editbox_val.set("00000")
        self.editbox = Tkinter.Entry(self.frame, textvariable=self.editbox_val)
        self.editbox.pack(padx=5, side=Tkinter.RIGHT)

    def create_radiobutton1(self):
        self.frame = Tkinter.Frame(self.topframe)
        self.frame.pack(fill=Tkinter.BOTH, padx=10, pady=10)
        self.label = Tkinter.Label(
            self.frame, text=u"Number taken out of \nthe specified")
        self.label.grid(row=0, column=0)

        self.radiobutton_val1 = Tkinter.IntVar()
        self.radiobutton_val1.set(1)

        self.radiobutton = Tkinter.Radiobutton(
            self.frame, text="1", variable=self.radiobutton_val1, value=1)
        self.radiobutton.grid(row=0, column=1)

    def create_radiobutton2(self):
        self.frame = Tkinter.Frame(self.topframe)
        self.frame.pack(fill=Tkinter.BOTH, padx=10, pady=10)
        self.label = Tkinter.Label(
            self.frame, text="Up continuing"
            "\nreduction limit"
            "\nspecified")
        self.label.grid(row=0, column=0)
        self.radiobutton_val2 = Tkinter.IntVar()
        self.radiobutton_val2.set(2)

        self.radiobutton = Tkinter.Radiobutton(
            self.frame, text="1",
            variable=self.radiobutton_val2, value=1)
        self.radiobutton.grid(row=0, column=1, sticky=Tkinter.E)
        self.radiobutton = Tkinter.Radiobutton(
            self.frame, text="2", variable=self.radiobutton_val2, value=2)
        self.radiobutton.grid(row=0, column=2, sticky=Tkinter.E)

    def create_radiobutton3(self):
        self.frame = Tkinter.Frame(self.topframe)
        self.frame.pack(fill=Tkinter.BOTH, padx=10, pady=10)
        self.frame_label = Tkinter.Label(
            self.frame, text=u"Down continuing"
            "\nreduction limit"
            "\nspecified")
        self.frame_label.grid(row=0, column=0)

        self.radiobutton_val3 = Tkinter.IntVar()
        self.radiobutton_val3.set(2)

        self.radiobutton = Tkinter.Radiobutton(
            self.frame, text="1", variable=self.radiobutton_val3, value=1)
        self.radiobutton.grid(row=0, column=1, sticky=Tkinter.E)
        self.radiobutton = Tkinter.Radiobutton(
            self.frame, text="2", variable=self.radiobutton_val3, value=2)
        self.radiobutton.grid(row=0, column=2, sticky=Tkinter.E)

    def create_scaler1(self):
        self.frame = Tkinter.Frame(self.topframe)
        self.frame.pack(fill=Tkinter.BOTH, padx=10, pady=10)

        self.red1 = Tkinter.IntVar()
        self.red1.set(0)
        self.green1 = Tkinter.IntVar()
        self.green1.set(0)
        self.blue1 = Tkinter.IntVar()
        self.blue1.set(255)

        self.frame_scaler_label1 = Tkinter.Label(
            self.frame, text=u"Background color"
            "\n(output)"
            "\nspecification")
        self.frame_scaler_label1.grid(
            row=0, column=0, columnspan=1, sticky=Tkinter.W + Tkinter.E)
        self.frame_scaler_label1c = Tkinter.Label(
            self.frame, text=u"         \n         ")
        self.frame_scaler_label1c.grid(
            row=1, column=0, columnspan=1)

        self.name = Tkinter.Label(self.frame, text="red: ")
        self.name.grid(row=0, column=1)
        self.scale = Tkinter.Scale(
            self.frame, orient="h", length=150,
            from_=0, to=255, variable=self.red1,
            command=self.change_scaler_color1)
        self.scale.grid(row=0, column=2, sticky=Tkinter.E)

        self.name = Tkinter.Label(self.frame, text="green: ")
        self.name.grid(row=1, column=1)
        self.scale = Tkinter.Scale(
            self.frame, orient="h", length=150,
            from_=0, to=255, variable=self.green1,
            command=self.change_scaler_color1)
        self.scale.grid(row=1, column=2)

        self.name = Tkinter.Label(self.frame, text="blue: ")
        self.name.grid(row=2, column=1)
        self.scale = Tkinter.Scale(
            self.frame, orient="h", length=150,
            from_=0, to=255, variable=self.blue1,
            command=self.change_scaler_color1)
        self.scale.grid(row=2, column=2)

    def create_scaler2(self):
        self.frame = Tkinter.Frame(self.topframe)
        self.frame.pack(fill=Tkinter.BOTH, padx=10, pady=10)

        self.red2 = Tkinter.IntVar()
        self.red2.set(128)
        self.blue2 = Tkinter.IntVar()
        self.blue2.set(128)
        self.green2 = Tkinter.IntVar()
        self.green2.set(128)

        self.frame_scaler_label2 = Tkinter.Label(
            self.frame, text=u"Background color"
            "\n(reference)"
            "\nspecification")
        self.frame_scaler_label2.grid(
            row=0, column=0, columnspan=1, sticky=Tkinter.W + Tkinter.E)
        self.frame_scaler_label2c = Tkinter.Label(
            self.frame, text=u"         \n         ")
        self.frame_scaler_label2c.grid(
            row=1, column=0, columnspan=1)

        self.name = Tkinter.Label(self.frame, text="red: ")
        self.name.grid(row=0, column=1)
        self.scale = Tkinter.Scale(
            self.frame, orient="h", length=150, from_=0,
            to=255, variable=self.red2, command=self.change_scaler_color2)
        self.scale.grid(row=0, column=2)

        self.name = Tkinter.Label(self.frame, text="green: ")
        self.name.grid(row=1, column=1)
        self.scale = Tkinter.Scale(
            self.frame, orient="h", length=150,
            from_=0, to=255, variable=self.green2,
            command=self.change_scaler_color2)
        self.scale.grid(row=1, column=2)

        self.name = Tkinter.Label(self.frame, text="blue: ")
        self.name.grid(row=2, column=1)
        self.scale = Tkinter.Scale(
            self.frame, orient="h", length=150,
            from_=0, to=255, variable=self.blue2,
            command=self.change_scaler_color2)
        self.scale.grid(row=2, column=2)

    def change_scaler_color1(self, value):
        color = "#%02x%02x%02x" % (
            self.red1.get(), self.green1.get(), self.blue1.get())
        self.frame_scaler_label1c.configure(bg=color)

    def change_scaler_color2(self, value):
        color = "#%02x%02x%02x" % (
            self.red2.get(), self.green2.get(), self.blue2.get())
        self.frame_scaler_label2c.configure(bg=color)

    def click_button1(self):
        print u"PRAMETER SET BUTTON"

        tag = self.editbox_val.get()[:20]
        self.editbox_val.set(tag)
        self.param_data_set("PARAMETER_SET")

    def click_button2(self):
        print u"DEFAULT PARAMETER BUTTON"

        self.param_data_init()
        self.param_data_set("DEFAULT_PARAMETER_SET")

    def click_button3(self):
        print u"SYSTEM RESET BUTTON"
        self.on_reset()

    def param_data_init(self):
        self.editbox_val.set("00000")
        self.radiobutton_val1.set(1)
        self.radiobutton_val2.set(2)
        self.radiobutton_val3.set(2)

        self.red1.set(0)
        self.green1.set(0)
        self.blue1.set(255)

        self.red2.set(128)
        self.green2.set(128)
        self.blue2.set(128)

        color2 = "#808080"
        color1 = "#0000ff"

        self.frame_scaler_label1c.configure(bg=color1)
        self.frame_scaler_label2c.configure(bg=color2)

    def param_data_set(self, cmd):
        del self.param_data[:]
        self.param_data.append(cmd)
        self.param_data.append(self.editbox_val.get())
        self.param_data.append(self.radiobutton_val1.get())
        self.param_data.append(self.radiobutton_val2.get())
        self.param_data.append(self.radiobutton_val3.get())
        self.param_data.append(self.red1.get())
        self.param_data.append(self.green1.get())
        self.param_data.append(self.blue1.get())
        self.param_data.append(self.red2.get())
        self.param_data.append(self.green2.get())
        self.param_data.append(self.blue2.get())

        print self.param_data

        self.on_write(self.param_data)

    def set_on_write(self, func):
        self.on_write = func

    def set_on_reset(self, func):
        self.on_reset = func

    def show_info(self):
        print u"Frame.show_info"
        tkMessageBox.showinfo(
            u"info", u"Tag name is sure to enter in up to 20 characters."
            u"\n※20 characters or more truncation")


if __name__ == '__main__':
    print "f = CreateGUI()"
    f = CreateGUI()
    print "f.pack()"
    f.pack()
    print "f.mainloop()"
    f.mainloop()
